/*
 * Copyright (c) 1983, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
#if 0
static char sccsid[] = "@(#)io.c	8.1 (Berkeley) 6/6/93";
#endif
static const char rcsid[] =
  "$FreeBSD: src/usr.bin/talk/io.c,v 1.9.2.2 2001/10/15 13:42:07 dd Exp $";
#endif /* not lint */

/*
 * This file contains the I/O handling and the exchange of
 * edit characters. This connection itself is established in
 * ctl.c
 */

#include <errno.h>
#include <netdb.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <sys/filio.h>
#include "ssl.h"
#include "talk.h"
#include "talk_ctl.h"

#define A_LONG_TIME 10000000
#define UNDEFINED -1
#define BAD		0
#define GOOD	1

static int init_ssl = BAD;
static int out_of_timer = BAD;
/* 
 * peer_use_ssl is not significative 
 * until sign_no_ssl or ssl handshake 
 */
int peer_use_ssl= UNDEFINED; 

int ssl_on = FAIL;	/* peers are using ssl (finally) */

struct itimerval itimer;
	
void sign_no_ssl() {
	peer_use_ssl = DONT_USE_SSL;
	timerclear(&itimer.it_value);
	timerclear(&itimer.it_interval);
	setitimer(ITIMER_REAL, &itimer, (struct itimerval *)0);
	signal(SIGALRM, SIG_DFL);
}

void waiting_for_ssl_handshake() {
	itimer.it_value.tv_sec = 1;
	itimer.it_value.tv_usec = 0;
	itimer.it_interval = itimer.it_value;
	setitimer(ITIMER_REAL, &itimer, (struct itimerval *)0);
	signal(SIGALRM, sign_no_ssl);
}

/*
 * The routine to do the actual talking
 */
void
talk()
{
	struct hostent *hp, *hp2;
	int nb;
	fd_set read_set, read_template;
	char buf[BUFSIZ], **addr, *his_machine_name;
	struct timeval wait;

	his_machine_name = NULL;
	hp = gethostbyaddr((const char *)&his_machine_addr.s_addr,
	    sizeof(his_machine_addr.s_addr), AF_INET);
	
	if (hp != NULL) {
		hp2 = gethostbyname(hp->h_name);
		if (hp2 != NULL && hp2->h_addrtype == AF_INET &&
		    hp2->h_length == sizeof(his_machine_addr))
			for (addr = hp2->h_addr_list; *addr != NULL; addr++)
				if (memcmp(*addr, &his_machine_addr,
				    sizeof(his_machine_addr)) == 0) {
					his_machine_name = strdup(hp->h_name);
					break;
				}
	}
	if (his_machine_name == NULL)
		his_machine_name = strdup(inet_ntoa(his_machine_addr));
	snprintf(buf, sizeof(buf), "Connection established with %s@%s.",
	    msg.r_name, his_machine_name);
	free(his_machine_name);
	message(buf);
	write(STDOUT_FILENO, "\007\007\007", 3);
	
	current_line = 0;

	/*
	 * Wait on both the other process (sockt_mask) and
	 * standard input ( STDIN_MASK )
	 */
	FD_ZERO(&read_template);
	FD_SET(sockt, &read_template);
	FD_SET(fileno(stdin), &read_template);
	for (;;) {
		/* use_ssl == USE_SSL 	<-- user wants to use ssl */
		/* init_ssl == BAD		<--- i inizialized ssl handshake */
		/* peer_on_accept == BAD	<--- i started talk session */
		if (use_ssl == USE_SSL && init_ssl == BAD && peer_on_accept == BAD) { 
			write(sockt, "[Init SSL handshake... ",23);
			display(&my_win, "[Init SSL handshake... ",23);
			init_ssl = GOOD;
			waiting_for_ssl_handshake();
		}
		/* peer_use_ssl ==DONT_USE_SSL <--- var is set with no 
ssl */
		/* out_of_timer == BAD the handshake ends setting out_of_timer to GOOD */
		if (peer_use_ssl == DONT_USE_SSL && out_of_timer == BAD) {
			display(&my_win,"NO]\n", 4);
			out_of_timer = GOOD;
			write(sockt, "NO]\n", 4);
		}
		read_set = read_template;
		wait.tv_sec = A_LONG_TIME;
		wait.tv_usec = 0;
		nb = select(32, &read_set, 0, 0, &wait);
		if (nb <= 0) {
			if (errno == EINTR) {
				read_set = read_template;
				continue;
			}
			/* panic, we don't know what happened */
			p_error("Unexpected error from select");
			quit();
		}
		if (FD_ISSET(sockt, &read_set)) {
			/* There is data on sockt */
			if (ssl_on == SUCCESS)
				nb = SSL_read(ssl, buf, sizeof buf);
			else
				nb = read(sockt, buf, sizeof buf);
			if (nb <= 0) {
				message("Connection closed. Exiting");
				quit();
			}
			if (use_ssl == USE_SSL) {
				if (!strncmp(buf, "[Init SSL handshake... ", 23) && init_ssl == BAD) {
					init_ssl = GOOD;
					display(&my_win, "[Peer wants to use SSL... good!]\n", 33);
					write (sockt, "OK]", 4);
					
					if (peer_on_accept == GOOD) {
						display(&my_win, "[SSL Accept]\n", 12);
						if (accept_ssl() == FAIL) {
							fprintf(stderr,"accept_ssl() error\n");
						}
						else {
							display(&my_win, "[OK]\n", 5);
							ssl_on = SUCCESS;
						}
					}
				}
				else if (!strncmp(buf, "OK]", 4) && init_ssl == GOOD) {
					display(&my_win, "OK]\n", 4);
					peer_use_ssl = USE_SSL;
					timerclear(&itimer.it_value);
					timerclear(&itimer.it_interval);
					setitimer(ITIMER_REAL, &itimer, (struct itimerval *)0);
					signal(SIGALRM, SIG_DFL);
					out_of_timer = GOOD;
					display(&my_win, "[SSL Connect]\n", 13);
					if (connect_ssl() == FAIL) {
							fprintf(stderr,"connect_ssl() error\n");
						}
					else {
						display(&my_win, "[OK]\n", 5);
						ssl_on = SUCCESS;
					}
						
				}
				else
					display(&his_win, buf, nb);
			}
			else 
				display(&his_win, buf, nb);
		}
		if (FD_ISSET(fileno(stdin), &read_set)) {
			/*
			 * We can't make the tty non_blocking, because
			 * curses's output routines would screw up
			 */
			int i;
			ioctl(fileno(stdin), FIONREAD, (struct sgttyb *) &nb);
			nb = read(fileno(stdin), buf, nb);
			display(&my_win, buf, nb);
			/* might lose data here because sockt is non-blocking */
			for (i = 0; i < nb; ++i)
				if (buf[i] == '\r')
					buf[i] = '\n';
			if (ssl_on == SUCCESS)
				SSL_write(ssl, buf, nb);
			else
				write(sockt, buf, nb);
		}
	}
}

/*
 * p_error prints the system error message on the standard location
 * on the screen and then exits. (i.e. a curses version of perror)
 */
void
p_error(string)
	char *string;
{
	wmove(my_win.x_win, current_line, 0);
	wprintw(my_win.x_win, "[%s : %s (%d)]\n",
	    string, strerror(errno), errno);
	wrefresh(my_win.x_win);
	move(LINES-1, 0);
	refresh();
	quit();
}

/*
 * Display string in the standard location
 */
void
message(string)
	char *string;
{
	wmove(my_win.x_win, current_line, 0);
	wprintw(my_win.x_win, "[%s]\n", string);
	if (current_line < my_win.x_nlines - 1)
		current_line++;
	wrefresh(my_win.x_win);
}
